#include "hmg.ch"
#include "harupdf.ch"

//#include "minigui.ch"



Function Main
parameters cmdline

public my_compiler

public path 
#include "mdir.ch"

set exclusive on

if pcount() < 1
   path := "No Database in USE"
else
   path := cmdline
   use &path 
endif

set date german

my_compiler:=( hb_compiler() + "  " + version() )

    DEFINE WINDOW Win_1 ;
        AT 0,0 ;
        WIDTH 800 HEIGHT 600 ;
        TITLE 'My Database Utility' ;
        ICON 'WORLD' ;
        MAIN NOMAXIMIZE ;
        ON INIT OpenTables();
        ON RELEASE CloseTables();
        BACKCOLOR GRAY

        DEFINE MAIN MENU 
            POPUP 'File'
                ITEM 'File Open' ACTION getdbf()
                ITEM 'Structure' ACTION mystru( fcount() )
     		       ITEM "Simple Edit test"   ACTION  dbshow( ALIAS() )
       		    ITEM "Create Database"   ACTION showstru( ALIAS() )
                ITEM "Mdir           "   ACTION ( xdir('*.*') , ;
                                                  myuse()       )
                SEPARATOR
                ITEM 'Exit' ACTION Win_1.Release
            END POPUP
            POPUP 'Other'
                ITEM 'Make PDF' ACTION dopdf()
                 //   ITEM 'Show' ACTION Show( path )
            END POPUP
            POPUP 'Information'
                ITEM 'ALIASES' ACTION myAlias()
                ITEM 'About' ACTION myAbout()
            END POPUP
        END MENU

	DEFINE STATUSBAR 
            STATUSITEM path 
            CLOCK 
            DATE  WIDTH 100
            
   END STATUSBAR


   END WINDOW

   CENTER WINDOW Win_1

   ACTIVATE WINDOW Win_1

Return Nil

PROCEDURE myappend
dbappend()
go reccount()
Return Nil

Procedure OpenTables()

Return Nil

Procedure CloseTables()
    dbcloseall()
Return Nil

procedure dbshow
my_alias:=ALIAS()
EDIT EXTENDED WORKAREA &my_alias 
return nil




Procedure donothing
return Nil


Procedure getdbf()
Local x
use
path := Getfile ( { {'All Files','*.dbf'} } , 'Open File' , '' , .f. , .t. )

     if len( path ) > 1
           use &path             
           go 1
           Win_1.StatusBar.Item( 1 ) := path
           Win_1.StatusBar.Refresh
           Return 
     endif
Return 

function myuse
         if at("DBF",UPPER(path) ) < 1
             Win_1.StatusBar.Item( 1 ) := path
             return nil
         endif
         if len( path ) > 1 
            use &path
            go 1
            Win_1.StatusBar.Item( 1 ) := path
            Return nil
         endif
return nil


Function Show
para xtest
local xx:=xtest
local mytext:=space(5000)
     
     if IsWindowDefined ( Show_1  )
       return
    endif    
     
      fd:=fopen( xx )
      fread(fd,@mytext,5000)
      fclose(fd)

    DEFINE WINDOW Show_1 ;
        AT 0,0 ;
        WIDTH GetDesktopWidth()-40 ;
        HEIGHT GetDesktopHeight()-40 ;
        TITLE 'Show File   : ' + xx ;
        NOMAXIMIZE ; 
        NOMINIMIZE

        @ 20,20 EDITBOX Edit_1 ;
		  WIDTH GetDesktopWidth() - 60 ;
		  HEIGHT GetDesktopHeight() - 60 ;
		  VALUE @mytext ;
		  TOOLTIP 'EditBox' ;
		  MAXLENGTH 255 
    END WINDOW
    
    Show_1.Center
    Show_1.Activate
Return nil

Procedure myAbout()
    
    if IsWindowDefined ( win_about  )
       return
    endif    

    DEFINE WINDOW win_about ;
        AT 0,0 ;
        WIDTH 400 HEIGHT 260 ;
        NOMAXIMIZE ;
        NOMINIMIZE ;
        NOCAPTION ;
        TITLE 'About' 
        
        ON KEY ESCAPE ACTION win_about.release

        @ 10,170 IMAGE KLAUS ;
          PICTURE "KLAUS.JPG";
          WIDTH  240 ;
          HEIGHT 192 ; 
          ACTION win_about.Release
  
        @ 10,10 LABEL cComp ;
          WIDTH 180 ;
          HEIGHT 60 ;
          FONT "Arial" BOLD SIZE 9 ;
          VALUE my_compiler 

        @ 70,10 LABEL cName ;
          WIDTH 180 ;
          HEIGHT 60 ;
          FONT "Arial" BOLD SIZE 9 ;
          VALUE 'Klaus Kugel 2012'



        @ 90,10 LABEL cCopy ;
          WIDTH 160 ;
          HEIGHT 40 ;
          FONT "Arial" BOLD SIZE 9 ;
          VALUE 'Released under the GPL'

        @ 215,10 LABEL cOS ;
          WIDTH 350 ;
          HEIGHT 40 ;
          FONT "Arial" BOLD SIZE 9 ;
          VALUE OS()
        
    END WINDOW

    CENTER WINDOW win_about
    ACTIVATE WINDOW win_about

return Nil


procedure mypath
parameters xx_path
     set default to xx_path 
     msginfo( xx_path )
return nil


procedure mystru( )
para anz

local xtitle,mystruc,nField,x_type,x_len,x_dec
local aRows[anz][4]

    if IsWindowDefined ( win_stru  )
       return
    endif    

    if len(alias()) > 0
        xtitle:="Structure of Database : "+ALIAS()
    else
        xtitle:="Structure of Database"
    endif
    DEFINE WINDOW win_stru ;
        AT 0,0 ;
        WIDTH 640 HEIGHT 440 ;
        NOMAXIMIZE ;
        TITLE xtitle ;
        ON INIT donothing();
        ON RELEASE donothing()
        ON KEY ESCAPE ACTION win_stru.release

      mystruc:=dbstruct()
      for  nField := 1 to len( mystruc )
          x_type := mystruc[nField,2]
          x_len  := str( mystruc[nField,3] )
          x_dec  := str( mystruc[nField,4] )
          aRows[nField]  := { mystruc[nField,1],x_type,x_len,x_dec }
      next

		@ 10,10 GRID Grid_stru ;
		WIDTH 600 ;
		HEIGHT 400 ;
		HEADERS { 'Field Name','Type','Length','Dec'} ;
		WIDTHS { 140 ,60, 100, 100 };
		ITEMS aRows ;
		VALUE 1 ;
		TOOLTIP 'Editable Grid Control' ;
                JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT }
        
    END WINDOW

    CENTER WINDOW win_stru

    ACTIVATE WINDOW win_stru

return nil



Procedure myAlias()
    local a_alias[255],i

    if IsWindowDefined ( w_alias  )
       return
    endif    
   
    DEFINE WINDOW w_alias ;
        AT 0,0 ;
        WIDTH 350 ;
        HEIGHT 350 ;
        NOMAXIMIZE ;
        TITLE 'Aliases of Databases' 
        ON KEY ESCAPE ACTION w_alias.release

        for i:= 1 to 255
            a_alias[i] := { str(i)+"  "+alias(i) }
        next

	     @ 10,10 GRID grid_a ;
		  WIDTH 200 ;
	     HEIGHT 200 ;
        FONT "ARIAL" SIZE 10 BOLD;
		  HEADERS { 'Area    |   ALIAS  '} ;
		  WIDTHS { 210 };
		  ITEMS a_alias ;
		  VALUE 1 ;
        ON DBLCLICK  dbselectarea (str(w_alias.grid_a.value ) ) ;
	  	  TOOLTIP 'Editable Grid Control' ;
                JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT }       

        @ 300,10 LABEL x_note ;
        WIDTH 250 ;
        HEIGHT 40 ;
        FONT "Arial" BOLD SIZE 9 ;
        VALUE "Double Click to select AREA"
                
    END WINDOW

    CENTER WINDOW w_Alias

    ACTIVATE WINDOW w_Alias

return nil

//---------------------------------
//-- End of DBU 
//---------------------------------

//--- Start dbcr - textfunc


Function showstru
para mypath

PUBLIC anz:=2

PUBLIC aRows [anz] [4]

Public Op

public aRows := array(fcount(),4)

//------------------
     mystruc:=dbstruct()
     for  nField := 1 to len( mystruc )
     x_type := mystruc[nField,2]
     x_len  := str( mystruc[nField,3] )
     x_dec  := str( mystruc[nField,4] )
     aRows[nField]  := { mystruc[nField,1],x_type,x_len,x_dec }
     next
//-----------------
    if IsWindowDefined ( Form_1  )
       return
    endif    

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 740 ;
		HEIGHT 440 ;
		TITLE 'Create Database' ;
		FONT 'Arial' ;
		SIZE 9

		DEFINE LABEL Label_1
			ROW	10
			COL	10
			WIDTH	60
			VALUE 'Fieldname'
		END LABEL

		DEFINE TEXTBOX Text_1
			ROW	30
			COL	10
			WIDTH	80
		END TEXTBOX

		DEFINE LABEL Label_2
			ROW	10
			COL	200
			WIDTH	50
			VALUE	'Type'
		END LABEL

		DEFINE TEXTBOX Text_2
			ROW	30
			COL	200
			WIDTH	40
		END TEXTBOX

		DEFINE LABEL Label_3
			ROW	10
			COL	385
			WIDTH	60
			VALUE	'Length'
		END LABEL

		DEFINE TEXTBOX Text_3
			ROW	30
			COL	385
			WIDTH	50
		END TEXTBOX

 		DEFINE LABEL Label_4
			ROW	10
			COL	470
			WIDTH	80
			VALUE	'Decimals'
		END LABEL

		DEFINE TEXTBOX Text_4
			ROW	30
			COL	470
			WIDTH	50
		END TEXTBOX

		DEFINE BUTTON Button_A
			ROW	10
			COL	620
			WIDTH	105
			CAPTION	'Ok'
			ACTION    Ok()
		END BUTTON

		DEFINE BUTTON Button_B
			ROW	40
			COL	620
			WIDTH	105
			CAPTION	'Cancel'
			ACTION	Cancel()
		END BUTTON

		DEFINE BUTTON Button_C
			ROW	70
			COL	620
			WIDTH	105
			CAPTION	'Create Database'
			ACTION	 make_base()
		END BUTTON
		DEFINE BUTTON Button_D
			ROW	100
			COL	620
			WIDTH	105
			CAPTION	'Create Structure'
			ACTION	 create_base()
		END BUTTON
		DEFINE BUTTON Button_E
			ROW	250
			COL	620
			WIDTH	105
			CAPTION	'Structure Function'
			ACTION	 func_stru("crklaus")
		END BUTTON
 
		DEFINE GRID Grid_1 
			ROW 	80
			COL	10
			WIDTH	520 
			HEIGHT	300 
			HEADERS	{ 'FIELDNAME' , 'FIELDTYPE' , 'LENGTH', 'DEC' } 
			WIDTHS	{ 185 , 185 , 90 , 55 }
			ITEMS	aRows 
			VALUE	1 
         ON DBLCLICK aendern()
		END GRID

		DEFINE BUTTON Button_1
			ROW	130
			COL	620
         WIDTH   105
			CAPTION	'Add Field'
			ACTION	 hinzu()
		END BUTTON

		DEFINE BUTTON Button_2
			ROW	160
			COL	620
         WIDTH   105
			CAPTION	'Delete Field'
			ACTION	 loeschen()
		END BUTTON

		DEFINE BUTTON Button_3
			ROW	190
			COL	620
         WIDTH   105
			CAPTION	'Alter Field'
			ACTION	aendern()
		END BUTTON
	
    	DEFINE BUTTON Button_4
			ROW	220
			COL	620
         WIDTH   105
			CAPTION	'Quit'
			ACTION	Form_1.release
		END BUTTON

	END WINDOW

	Form_1.Text_1.Enabled :=.f.
	Form_1.Text_2.Enabled :=.f.
	Form_1.Text_3.Enabled :=.f.
	Form_1.Text_4.Enabled :=.f.
	Form_1.Button_A.Enabled :=.f.
	Form_1.Button_B.Enabled :=.f.
   Form_1.Grid_1.Refresh

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return nil

Procedure hinzu()
	Op := 'HINZU'
	Form_1.Text_1.Enabled :=.t.
	Form_1.Text_2.Enabled :=.t.
	Form_1.Text_3.Enabled :=.t.
   Form_1.Text_4.Enabled :=.t.
	Form_1.Button_1.Enabled :=.f.
	Form_1.Button_2.Enabled :=.f.
	Form_1.Button_3.Enabled :=.f.
	Form_1.Button_A.Enabled :=.t.
	Form_1.Button_B.Enabled :=.t.
	Form_1.Grid_1.Enabled := .f.

	Form_1.Text_1.SetFocus
Return

Procedure loeschen() // Delete Field-Item
Local i := Form_1.Grid_1.Value
	If i != 0
		Form_1.Grid_1.DeleteItem(i)
	EndIf
Return

Procedure make_base()           // Create DBF-File
local nFieldcount := Form_1.Grid_1.ItemCount
local aTemp
local aXbase:=Array( Form_1.Grid_1.ItemCount, 4 )

local outstru:=space(20)
      outstru:=getname()

       if len( alltrim( outstru ) ) < 1
         return nil
       endif

       for x_ := 1 to nFieldCount
               aTemp := Form_1.Grid_1.Item(x_)
               aXbase[x_,1] := aTemp[1]
               aXbase[x_,2] := aTemp[2]
               aXbase[x_,3]:=Val(aTemp[3])
               aXbase[x_,4]:=Val(aTemp[4])
       next 

       if !file( outstru+".dbf")
             DbCreate( outstru ,  aXbase  )
             msginfo( " Database "+outstru+" created " )
       else
             msginfo( " Database "+outstru+" exists, please use another Name " )
       endif       
Return nil

//---------------------------------

Procedure create_base()  // Create Source-File for Code-Insertion
para x_x
local outstru
local nFieldcount := Form_1.Grid_1.ItemCount
local aTemp
local aXbase:=Array( Form_1.Grid_1.ItemCount, 4 )
local d:=chr( asc('"'))

      outstru:=getname()
      if len( alltrim(outstru) ) < 1
              return nil
      endif

//-------
        myhandle:= fcreate(outstru,0)
                   fwrite(myhandle,"FUNCTION ",9)
                   fwrite(myhandle,upper(outstru),len(outstru))
                   fwrite(myhandle,chr(13)+chr(10),2)
                   fwrite(myhandle,"FIELD_LIST := {}",16)
                   fwrite(myhandle,chr(13)+chr(10),2)
//---------

        for x_ := 1 to nFieldCount
            aTemp := Form_1.Grid_1.Item(x_)
            fwrite(myhandle,"AADD( FIELD_LIST ,",18)
            fwrite(myhandle,'{"',2)
            fwrite(myhandle,aTemp[1],len(aTemp[1])) 
            fwrite(myhandle,'","',3)
            fwrite(myhandle,aTemp[2],len(aTemp[2]))
            fwrite(myhandle,'",',2)
            fwrite(myhandle,aTemp[3],len(aTemp[3]))
            fwrite(myhandle,',',1)
            fwrite(myhandle,aTemp[4],len(aTemp[4]))
            fwrite(myhandle,' } ) ',5)
            fwrite(myhandle,chr(13)+chr(10),2)
         next
//---------                  

            fwrite(myhandle,"DBCREATE(",9)
            fwrite(myhandle,UPPER(d+substr(outstru,1,len(outstru))+d),( len(outstru) + 2 ) )
            fwrite(myhandle,", FIELD_LIST ",13)
            fwrite(myhandle,")",1)
            fwrite(myhandle,chr(13)+chr(10),2)
            fwrite(myhandle,"Return nil",10)
            fwrite(myhandle,chr(13)+chr(10),2)
            fclose( myhandle )
            msginfo("Database Structure Function"+UPPER(outstru)+" created ")


Return nil
//---------------

Function dopdf              // List Structure Of DBF-Table in PDF-File

   Local i, page, height, width, def_font, tw,  samp_text, font , print_date, print_anz
   Local page_title := "Vouch"
   Local cResPath := "files"+"\"
   Local cAfm := cResPath+"a010013l.afm"
   Local cPfb := cResPath+"a010013l.pfb"
   Local encodings := { ;
            "StandardEncoding",;
            "MacRomanEncoding",;
            "WinAnsiEncoding", ;
            "ISO8859-2",       ;
            "ISO8859-3",       ;
            "ISO8859-4",       ;
            "ISO8859-5",       ;
            "ISO8859-9",       ;
            "ISO8859-10",      ;
            "ISO8859-13",      ;
            "ISO8859-14",      ;
            "ISO8859-15",      ;
            "ISO8859-16",      ;
            "CP1250",          ;
            "CP1251",          ;
            "CP1252",          ;
            "CP1254",          ;
            "CP1257",          ;
            "KOI8-R",          ;
            "Symbol-Set",      ;
            "ZapfDingbats-Set" }
   Local font_list  := { ;
                        "Courier",                  ;
                        "Courier-Bold",             ;
                        "Courier-Oblique",          ;
                        "Courier-BoldOblique",      ;
                        "Helvetica",                ;
                        "Helvetica-Bold",           ;
                        "Helvetica-Oblique",        ;
                        "Helvetica-BoldOblique",    ;
                        "Times-Roman",              ;
                        "Times-Bold",               ;
                        "Times-Italic",             ;
                        "Times-BoldItalic",         ;
                        "Symbol",                   ;
                        "ZapfDingbats"              ;
                      }

//---------------------------------------+++
  LOCAL my_pdf   
  LOCAL anz:=1 
  LOCAL myheight := 0
  LOCAL aRows := array(fcount(),4)
  local x_type,x_len,x_dec, nField
//--------
     Local pdf := HPDF_New()         
//------------------

     mystruc:=dbstruct()
     for  nField := 1 to len( mystruc )
          x_type := mystruc[nField,2]
          x_len  := str( mystruc[nField,3] )
          x_dec  := str( mystruc[nField,4] )
          aRows[nField]  := { mystruc[nField,1],x_type,x_len,x_dec }
     next
                      
//----------------------------------------++++                      
 

   if pdf == NIL
      alert( " Pdf could not been created!" )
      return nil
   endif


  /* set compression mode */

   HPDF_SetCompressionMode( pdf, HPDF_COMP_ALL )

   
  // Passwords and Permissions

   HPDF_SetPassword(pdf, "Klaus", NIL )           // If NIL Everyone can look but not modify
   HPDF_SetPermission(pdf, HPDF_ENABLE_PRINT)        // can print
   HPDF_SetEncryptionMode(pdf, HPDF_ENCRYPT_R3, 16)      // Highest current Encryption mode 12


   page := HPDF_AddPage(pdf)
   height := HPDF_Page_GetHeight(page)
   width  := HPDF_Page_GetWidth(page)

   def_font := HPDF_GetFont( pdf, "Courier", "WinAnsiEncoding" )          // WinAnsiEncoding because of Germansky
   def_fontB := HPDF_GetFont( pdf, "Courier-Bold", "WinAnsiEncoding" )

   font_name := HPDF_LoadType1FontFromFile(pdf, cAfm, cPfb )
   HPDF_Page_SetFontAndSize( page, def_font, 12 )

//-------------------------------

   myimage := HPDF_LoadJPegImageFromFile(pdf, "HMGLOGO.JPG" ) 
   iw := HPDF_Image_GetWidth( myimage ) / 6 * 1.2
   ih := HPDF_Image_GetHeight( myimage ) / 6 * 1.2
   HPDF_Page_SetLineWidth(page, 0.5)
   x := 535 
   y := 780  
   
   HPDF_Page_DrawImage(page, myimage, x , y, iw, ih)
//---------------------------
  
   HPDF_Page_BeginText( page )
   HPDF_Page_SetFontAndSize( page, def_fontB, 12 )
   HPDF_Page_TextOut( page, 40, height - 42, "Structure of Database : "+alias() )

   myheight:= height
   for anz = 1 to len( mystruc )
   print_anz :=  STR( anz ,3 )
   myheight=height - ( anz * 9 ) - 60
   HPDF_Page_TextOut( page, 40, myheight, print_anz+"  "+padright( aRows[anz,1],12 )+"  "+aRows[anz,2]+"  "+aRows[anz,3]+" "+aRows[anz,4] ) // alltrim( me->strasse) )
   next

   HPDF_Page_SetFontAndSize( page, def_fontB, 12 )

   print_date := date()   

   HPDF_Page_TextOut( page, 40, myheight - 18 , ;
   "Structure of   "+alias()+" printed   " +str(year( print_date )  ) +"/"+str(month(print_date))+"/"+str(day(print_date) )  )
   
   HPDF_Page_EndText( page )


   HPDF_SetInfoAttr( pdf, HPDF_INFO_TITLE ,  "Application" )
   HPDF_SetInfoAttr( pdf, HPDF_INFO_CREATOR ,"Klaus Kugel / HMG+Harbour+HaruPDF 2.3.0RC" )
   HPDF_SetInfoAttr( pdf, HPDF_INFO_AUTHOR , "Klaus Kugel 2012" )
   HPDF_SetInfoAttr( pdf, HPDF_INFO_SUBJECT, "for " )
   HPDF_SetInfoAttr( pdf, HPDF_INFO_KEYWORDS,"HMG 3.0.44 / Harbour 3.2dev " )
   my_pdf :=( alias()+".pdf" )
   HPDF_SaveToFile( pdf, ( alias()+".pdf" ) )
   HPDF_Free( pdf )
   execute file ( alias()+".pdf" )
       
Return  nil 

// End of doPDF() Function

Procedure func_stru()
para outstru
local nFieldcount := Form_1.Grid_1.ItemCount
local aTemp
local aXbase:=Array( Form_1.Grid_1.ItemCount, 4 )
local d:=chr( asc('"'))
local myfunc:=space(904)

         outstru:=getname()
         if len( alltrim(outstru) ) < 1
             return nil
         endif
//-------
         myfunc := "FUNCTION "+upper(outstru)
         myfunc += chr(13)+chr(10)
         myfunc += "FIELD_LIST := {}"
         myfunc += chr(13)+chr(10)
//---------
   for x_ := 1 to nFieldCount
         aTemp := Form_1.Grid_1.Item(x_)
         myfunc += "AADD( FIELD_LIST ,"
         myfunc += '{"'
         myfunc += aTemp[1] 
         myfunc += '","'
         myfunc += aTemp[2]
         myfunc += '",'
         myfunc += aTemp[3]
         myfunc += ','
         myfunc += aTemp[4]
         myfunc += ' } ) '
         myfunc += chr(13)+chr(10)
    next
//---------                  
         myfunc += "DBCREATE("
         myfunc += UPPER(d+substr(outstru,1,len(outstru))+d)
         myfunc += ", FIELD_LIST )"
         myfunc += chr(13)+chr(10)
         myfunc += "Return nil"
         myfunc += chr(13)+chr(10)
//------

         showfile( myfunc )
Return nil

procedure showfile
para file_name

    if IsWindowDefined ( SF_1  )
       return
    endif    



    DEFINE WINDOW SF_1 ;
        AT 0,0 ;
        WIDTH 440 ;
        HEIGHT 380 ;
        TITLE 'Show Structure Function' ;

        @ 10,20 EDITBOX myEDIT ;
        WIDTH 400 ;
        HEIGHT 300 ;
        VALUE '           '

        SF_1.myEDIT.VALUE:=file_name

    END WINDOW
    CENTER WINDOW SF_1
    ACTIVATE WINDOW SF_1

return nil


function getname
local g_path
    if IsWindowDefined ( fGetname  )
       return
    endif    
   
    DEFINE WINDOW fGetname ;
        AT 0,0 ;
        WIDTH 450 ;
        HEIGHT 100 ;
        NOMAXIMIZE ;
        NOMINIMIZE ;
        TITLE 'New Database Name without .DBF Extension ' ;
        ON RELEASE g_path :=alltrim( UPPER( fGetname.myEDIT.VALUE ) ) 

        @ 10,20 TEXTBOX myEDIT ;
                FONT "Arial" SIZE 10 ;
                WIDTH  150 ;
                HEIGHT 30 ;
                VALUE '        '

                @ 10,170 BUTTON myButton_1 ;
                CAPTION 'OK' ;
                WIDTH 80  ;
                HEIGHT 30  ;   
                FONT 'Arial' BOLD SIZE 12 ;             
                ACTION ( fGetname.Release )

                @ 10,260 BUTTON myButton_2 ;
                CAPTION 'CANCEL' ;
                WIDTH 80  ;
                HEIGHT 30  ;                
                FONT 'Arial' BOLD SIZE 12 ;
                ACTION ( msginfo('No File selected') ,g_path:='', ;
                fGetname.Release )



    END WINDOW
    CENTER WINDOW fGetname
    ACTIVATE WINDOW fGetname

RETURN ( alltrim( UPPER( g_path )) )



//---------------------------------

Procedure aendern()
Local i := Form_1.Grid_1.Value , aTemp

	Op := 'AENDERN'

	If i != 0

		aTemp := Form_1.Grid_1.Item(i)

		Form_1.Text_1.Value := aTemp [1]
		Form_1.Text_2.Value := aTemp [2]
		Form_1.Text_3.Value := aTemp [3]
		Form_1.Text_4.Value := aTemp [4]

		Form_1.Text_1.Enabled :=.t.
		Form_1.Text_2.Enabled :=.t.
		Form_1.Text_3.Enabled :=.t.
		Form_1.Text_4.Enabled :=.t.

		Form_1.Button_1.Enabled :=.f.
		Form_1.Button_2.Enabled :=.f.
		Form_1.Button_3.Enabled :=.f.

		Form_1.Button_A.Enabled :=.t.
		Form_1.Button_B.Enabled :=.t.

		Form_1.Grid_1.Enabled := .f.

		Form_1.Text_1.SetFocus

	EndIf

Return

Procedure Ok()
Local aTemp := {} , i

	If	Op == 'HINZU'

		Form_1.Grid_1.AddItem ( { Form_1.Text_1.Value , Form_1.Text_2.Value , Form_1.Text_3.Value ,;
                Form_1.Text_4.Value } )
		Form_1.Grid_1.Value := Form_1.Grid_1.ItemCount


	ElseIf	Op == 'AENDERN'

		i := Form_1.Grid_1.Value
		Form_1.Grid_1.Item (i) := { Form_1.Text_1.Value,Form_1.Text_2.Value ,;
                Form_1.Text_3.Value , Form_1.Text_4.Value }

	EndIf

	Form_1.Text_1.Value := ''
	Form_1.Text_2.Value := ''
	Form_1.Text_3.Value := ''
	Form_1.Text_4.Value := ''

	Form_1.Text_1.Enabled :=.f.
	Form_1.Text_2.Enabled :=.f.
	Form_1.Text_3.Enabled :=.f.
	Form_1.Text_4.Enabled :=.f.

	Form_1.Button_1.Enabled :=.t.
	Form_1.Button_2.Enabled :=.t.
	Form_1.Button_3.Enabled :=.t.

	Form_1.Button_A.Enabled :=.f.
	Form_1.Button_B.Enabled :=.f.

	Form_1.Grid_1.Enabled := .t.

	Form_1.Grid_1.SetFocus

Return

Procedure Cancel()

	Form_1.Text_1.Value := ''
	Form_1.Text_2.Value := ''
	Form_1.Text_3.Value := ''
	Form_1.Text_4.Value := ''

	Form_1.Text_1.Enabled :=.f.
	Form_1.Text_2.Enabled :=.f.
	Form_1.Text_3.Enabled :=.f.
	Form_1.Text_4.Enabled :=.f.

	Form_1.Button_1.Enabled :=.t.
	Form_1.Button_2.Enabled :=.t.
	Form_1.Button_3.Enabled :=.t.

	Form_1.Button_A.Enabled :=.f.
	Form_1.Button_B.Enabled :=.f.

	Form_1.Grid_1.Enabled := .t.

	Form_1.Grid_1.SetFocus
Return

#include "mdir.prg"